set lines 300
set pages 55
set pau "Press ENTER to continue ..."
set echo on
drop table ptest4a purge
/
drop table ptest4b purge
/
create table ptest4a
(
col1a number,
col2a varchar2(200),
col3a varchar2(200)
)
partition by hash (col1a)
partitions 4
/
create table ptest4b
(
col1b number,
col2b varchar2(200),
col3b varchar2(200)
)
partition by hash (col1b)
partitions 4
/
insert into ptest4a
select rownum, object_type, object_name
from all_objects
where rownum < 10001
/
insert into ptest4b
select rownum, object_type, object_name
from all_objects
where rownum < 10001
/
commit
/
begin
	dbms_stats.gather_table_stats (
		ownname	=> 'ARUP',
		tabname	=> 'PTEST4A',
		granularity	=> 'ALL',
		cascade	=> true
	);
end;
/
begin
   dbms_stats.gather_table_stats (
           ownname => 'ARUP',
           tabname => 'PTEST4B',
           granularity     => 'ALL',
           cascade => true
   );
end;
/
pau
prompt Checking for Non-equality
explain plan for
select count(*)
from ptest4a , ptest4b
where ptest4b.col1b = ptest4a.col1a
and ptest4a.col1a between 1500 and 1700
/
pau
select * from table(dbms_xplan.display(format=>'TYPICAL'))
/
pau
prompt Now checking for Equality
explain plan for
select count(*)
from ptest4a , ptest4b
where ptest4b.col1b = ptest4a.col1a
and ptest4a.col1a = 1500
/
pau
select * from table(dbms_xplan.display(format=>'TYPICAL'))
/